#include<iostream>
#include<algorithm>
using namespace std;
#define ll long long
#define MAXN 76000
int main()
{
	ios_base::sync_with_stdio(false);cin.tie(0);
	int t;
	cin>>t;
	while(t--)
	{
		int n,m;
		ll a[MAXN],b[MAXN],nzd;
		cin>>n>>m;
		for(int i=0;i<n;i++) cin>>a[i];
		for(int i=0;i<m;i++) cin>>b[i];
		sort(a,a+n);
		sort(b,b+n);
		nzd=a[1]-a[0];
		for(int i=1;i<n-1;i++) nzd=__gcd(nzd,a[i+1]-a[i]);
		int ans=1;
		for(int i=0;i<n;i++) if((b[i]-a[0])%nzd==0) ans=0;
		cout<<ans<<'\n';
	}
	return 0;
}